
chrome.action.onClicked.addListener((tab) => {
  if(! tab.url.includes("chrome://")) {
    chrome.scripting.executeScript({
      target: { tabId: tab.id },
      function: start
    });
  }
});

function start() {
  if (localStorage.getItem("YouTube subtitles")) {
    return;
  } else {
    localStorage.setItem("YouTube subtitles", true);
  }
  let pre_row_text = "";
  let pre_text = "";
  let output = "";
  let observer;
  let config = {
    childList: true,
    characterData: true,
    subtree: true
  };
  let el = document.querySelector(".ytp-caption-window-container");
  let el2 = document.querySelector(".html5-video-container");

  observer = new MutationObserver(getSubtitles);
  observer.observe(el, config);
  el2.insertAdjacentHTML("beforeend", "<a class='teishi' download='subtitles.txt' style='font-size:40px;background:red;position:fixed;display:inline-block;left:20px;top:56px;cursor:pointer'>停止</a>");
  document.querySelector(".teishi").addEventListener("click", stop);

  function stop() {
    observer.disconnect();
    if (output.split("")[0] === " ") {
      output = output.replace(" ", "");
    }
    output = output.replace(/  /g, " ");
    download(output);
    document.querySelector(".teishi").remove();
    localStorage.removeItem("YouTube subtitles");
  }

  function download(output) {
    let blob = new Blob([output], {"type": "text/plain"});

    if (window.navigator.msSaveBlob) {
      window.navigator.msSaveBlob(blob, "subtitles.txt");
    } else {
      document.querySelector(".teishi").href = window.URL.createObjectURL(blob);
    }
  }

  function getSubtitles() {
    let row_text = document.querySelector(".ytp-caption-window-container").textContent;

    if (row_text !== "" && row_text !== pre_row_text) {
      let el_arr = document.getElementsByClassName("caption-visual-line");
      let text = "";
      let new_frag = "";
      let check_frag = "";

      for (let i = 0; i < el_arr.length; i++) {
        text += " ";
        text += el_arr[i].textContent;
      }

      new_frag = text.replace(pre_text, "");
      check_frag = pre_text.replace(text, "");

      if (
          (new_frag === text && check_frag === pre_text)
          || new_frag !== text
        ) {
        output += new_frag;
      }

      pre_row_text = row_text;
      pre_text = text;
    }
  }

}
